== WANTS
* Support for Derby database
* CSV Import
* OFX export
* VAT/GST UI
* Command Line interface/Class for loading accounts and transactions
* Mass selection of destination accounts for imported transactions.
* Info icon in a sell investment panel that calculate the estimated gains/loss for selling a transaction
* FIFO, and Lot performance calculations for securities. (http://groups.google.com/group/jgnash-user/browse_thread/thread/fe124ecf806857f3?hl=en)
* Moving option for a Transaction from one Register to other Register.
* Hyperlink option from the results in the Reports and Graphs to the concerned Transactions of the Registers.
* Drill down of split entries in Split Transactions by right clicking on ledger view.
** Flag budget exceptions?
* Direct Transaction entry option in the Ledger to avoid Transaction form.
* Formal Trial Balance report
* Budgeting
** annotation, similar to transaction annotation, so the user can reference the reason for an exception in any given period.
* Reinstate archive capability
* Open zipped backups instead of manually unzipping.
* HSQLDB 2.5.1 when released

* Add manual warning about placing jGnash in Program Files. (%AppData%\jGnash)
* Yahoo finance historical event download is not working due to upstream changes.

== Release 3.5.1
* 02/20/2020 Corrected a bug with jGnash.exe for Windows Platforms not working.
* 02/20/2020 Fixed a bug that was causing icons to no longer work on Windows Platforms.

== Release 3.5.0 __(File format change)__
* 02/03/2020 Updated to the latest Hibernate, Poi, and Commons CSV dependencies.
* 02/11/2020 jGnash will now restart automatically for Linux and OSX users after downloading the JavaFX dependencies.
* 02/10/2020 Restructured main classes to a package to make future development with jpackage cleaner (GitHub Pull Request #88) _[msgilligan]_
* 02/08/2020 Build system cleanup and consolidated the bootloader.
* 02/08/2020 Fix RuntimeException when the currency of a locale is unknown. (GitHub Pull Request #92) _[t-pa]_
* 02/08/2020 Updated to JavaFx 14-ea+8.
* 02/05/2020 The location for JavaFX dependency downloads has changed.  HTTPS is now used.
* 02/03/2020 Updated to the latest Picocli, Hikari, PDFBox and Netty dependencies.
* 01/19/2020 Correctly handle a change to the Yahoo finance cookie expiration date.
* 01/01/2020 Transactions may now be tagged and filtered with user managed Tags.
* 12/28/2019 Fixed poor transaction form behavior caused by opening a splits dialog and closing before adding entries.
* 12/27/2019 Reduced overhead for icon management.
* 12/26/2019 FontAwesome icons were updated resulting in some icon changes.
* 12/15/2019 Reworked the Engine API for advanced transaction tags.
* 12/14/2019 The Windows exe wrapper will now look in the registry if JAVA_HOME has not been set.

== Release 3.4.0
* 12/14/2019 jGnash now uses a Rust based exe launcher for Windows users that replaces Launch4j.
* 12/14/2019 Updated to the latest Picocli and Hibernate dependencies.
* 12/01/2019 Switching the recommended Windows JVM to AdoptOpenJDK.
* 12/01/2019 Removed old jGnash 2.35.1 workaround for bad UUID values.
* 12/01/2019 Added a List of Accounts report.
* 11/30/2019 Added an Export function for the account tree.
* 11/30/2019 The headers in the CSV export of an account are now localized.
* 11/30/2019 Changed the internal delimiter for transaction tags to allow use of commas (currently not user accessible).
* 11/29/2019 Added a Securities chapter to the Manual.
* 11/29/2019 Prevent a NPE when changing the Symbol of a Security shortly after viewing it's chart.
* 11/27/2019 Added support for IEXCloud as a data provider for Securities history.
* 11/16/2019 Switched to a public API introduced in JavaFX 9 to prevent table column reordering in the Budget View.
* 11/04/2019 Errors and warnings from a failed QIF import were not being displayed.
* 11/03/2019 Mt940 import now correctly handles files not encoded using ISO_8859_1.
* 11/03/2019 QIF import now correctly handles files not encoded using UTF8.
* 10/27/2019 Improved the behavior of the Report dialog when manually changing the scale.  The auto fit size toggles
             will be cleared automatically.
* 10/24/2019 Internal cleanup to improve handling of Client/Server network failures.
* 10/23/2019 Fixed a regression that prevented caching of hash codes.
* 10/19/2019 Updated to the latest H2 dependency.
* 10/01/2019 The majority of the build system was migrated to the Kotlin DSL.

== Release 3.3.0
* 09/21/2019 Updated to the latest Hibernate, HikariCP and PDFBox dependencies.
* 09/18/2019 The displayed columns for the Portfolio report can now be changed.
* 09/16/2019 Don't display an exception if tabular report generation is interrupted.
* 09/15/2019 The Date range of a Portfolio report can now be changed.
* 09/14/2019 Prevent a rare NPE that would occur when deleting an account shortly after closure of a tabular report.
* 09/14/2019 Updated to the latest Picocli and Commons Text dependencies.
* 09/12/2019 Updated to JavaFX 13 dependency.
* 09/08/2019 Custom style sheets can now be applied to theme the UI.
* 09/07/2019 Made changes to prevent a very rare ConcurrentModificationException when using a relational database.
* 09/01/2019 Fixed a source code encoding issue that caused issues when compiling and testing under Windows.
* 09/01/2019 Updated to the latest Netty dependency.
* 08/26/2019 The selected file type was ignored when exporting a register and the extension was not specified within
             the filename.
* 08/25/2019 Properly restore the configured page size of a report if it's not a custom size.
* 08/25/2019 Expanded the auto-completion API to improve unit testing robustness.
* 08/25/2019 Fixed a regression that was causing a failure to load .h2.db files.
* 08/25/2019 Added a new option to save/restore prior report dates and added a Reset button.  The default start date
             is now the 1st day of the month.
* 08/12/2019 Backup files are no longer created unless the data file/database has been changed during a session.
* 08/11/2019 Consolidated CSS to make customization easier.
* 08/11/2019 Prevent a transaction form null pointer exception at shutdown when working with a multi-currency files.

== Release 3.2.1
* 08/10/2019 Updated to JavaFX 13-ea+11 dependency.
* 08/04/2019 Corrected the column sizing behavior of tabular reports with long values.
* 08/03/2019 Changed H2 relation databases to use Asynchronous access instead of NIO for safer file access.
* 08/03/2019 Fixed a bug that was causing File > Save As to force files to a .bxds file if a period existed within the
             file name's path other than the file extension.
* 08/03/2019 Internal deduplication and cleanup of relational database code.
* 08/03/2019 Update to the latest Hibernate dependency.
* 07/30/2019 Reduced console messages about ignored use of font Layout tables when creating tabular reports.
* 07/27/2019 Updated to the latest Commons Lang, Commons Text, Commons Collections, Commons CSV, Netty
             and Picocli dependencies.
* 07/23/2019 The Create / Modify Security form was not validating the reported Currency had been set.
* 07/21/2019 Fixed a very old UI bug that would prevent table column width restoration for locales that use a comma
             for a decimal separator.  It would also trigger unit test failures for the same locales.
* 07/09/2019 Fixed an issue that was preventing the jGnash.exe file from detecting Java on some systems.
* 07/09/2019 Improved bootloader behavior when determining "lib" location. (GitHub Issue #84) _[Raven Kopelman]_
* 07/07/2019 Selected tabular rows may now be copied to the clipboard using CTRL-C.

== Release 3.2.0
* 07/05/2019 Fixed a bug that was preventing entry of investment transaction gains or losses without using the detailed
             entry form and specifying a gains and loss account.
* 07/05/2019 Fixed a bug that was causing backup files and database conversions to save in the wrong location or
             fail completely if a period existed within the file name's path other than the file extension.
* 07/05/2019 The style of selected odd rows of TreeTables were not consistent with even rows.
* 06/30/2019 Updated to latest Netty and PDFBox dependencies.
* 06/30/2019 The manual was missing from the distribution.
* 06/30/2019 Converted the manual to Latex and moved to manual process to improve build performance.
* 06/15/2019 Improved the speed of detecting a non converging IRR calculation.
* 06/15/2019 Protect against Reminders without descriptions.
* 06/14/2019 Tabular reports may now be exported to a spreadsheet.
* 06/01/2019 Updated to the latest Hibernate dependency.
* 05/26/2019 The current budget period is now highlighted for easier identification.
* 05/26/2019 Selected table rows were not using the user configured focus color.
* 05/22/2019 Added a context menu to copy selected transactions to the clipboard.

== Release 3.1.0 __(File format change)__
* 05/19/2019 Added a Today button to the Budget toolbar for easy refocus of the current period.
* 05/18/2019 The starting month for Budgets is now configurable.
* 05/04/2019 Correction for reports with running totals between periods incorrectly hiding accounts when the
             'hide zero balance accounts' box is selected.
* 05/03/2019 Improved the size behavior for Alert dialogs on 4K displays (GitHub Issue #82)
* 05/02/2019 Updated to the latest Netty dependency.
* 04/28/2019 Cleaned up selection focus visual issues in the Budget view caused by poor JavaFX behavior.
* 04/28/2019 Protect against unwanted Budget column reordering.
* 04/28/2019 The account column width may now be changed in the Budget view.
* 04/28/2019 Updated to JavaFX 12.0.1 dependency
* 04/27/2019 The rounding mode and scale for Budgets is now configurable.
* 04/24/2019 A JavaFX exception was being thrown during underlying changes to a budget.

== Release 3.0.4
* 04/15/2019 The jGnash launch script now works correctly when double clicked in MacOS. (GitHub Pull Request #80) _[Pranay Kumar]_
* 04/14/2019 Disable the Portfolio report if there are not any investment accounts.
* 04/14/2019 A NPE could occur if the last investment account was deleted after showing the Portfolio report.
* 04/13/2019 Eliminated zero width spaces from the export of a register to a xls/xlsx file.
* 04/13/2019 Updated to latest POI and PDFBox dependencies.
* 04/07/2019 A Reminders chapter was added to the manual.
* 04/09/2019 Made the Enabled check box of the New Reminder dialog enabled by default.
* 04/07/2019 Improved shutdown speed if background events are occurring.
* 04/05/2019 Made internal changes to prevent race conditions during a shutdown.
* 04/05/2019 Calculate opening balance if user changes reconcile date. (GitHub Pull Request #79) _[Pranay Kumar]_
* 04/04/2019 Prevent an NPE caused by a race condition between recurring transactions being processed and an
             application shutdown in process. (GitHub Issue #78)
* 04/04/2019 Prevent accumulation of stale internal listeners that would result in wasted system memory and a slowdown
             during a long running session.

== Release 3.0.3
* 04/01/2019 Enhanced error handling for relational database to make identification of errors easier.
* 04/01/2019 Correct validation of numeric input when using a comma as a decimal separator. (GitHub Issue #77)

== Release 3.0.2
* 03/31/2019 Closing a register window with CTRL-F4 was not working.
* 03/31/2019 Added a command line option to bypass the bootloader.
* 03/31/2019 The wrong version information was being reported on the console when requested.
* 03/30/2019 Automatic column widths will now update correctly if numeric or date formats change.
* 03/30/2019 Use a full commodity format for the Total column in the investment register.
* 03/30/2019 Changes to preferred date and numeric formats will now trigger an immediate update of the active register.
* 03/29/2019 Improved detection and handling of invalid decimal input.
* 03/29/2019 Removed direct print support from the report dialog.  The user can use save the PDF and print it.
* 03/28/2019 Reimplemented the page format dialog for reports to address OSX issues and to allow custom paper sizes.
* 03/28/2019 Prevent an NPE from a race condition between a background security price update and an application shutdown.
* 03/27/2019 Prevent an NPE from occurring when closing after a report has been shown and GC is slow.
* 03/26/2019 Improved the update behavior when performing a Save As and when packing databases.
* 03/26/2019 The pack database action was not listing .mv.db files.
* 03/24/2019 Cleanup of language files to make translation and updates easier.

== Release 3.0.1
* 03/22/2019 Corrected a very rare concurrency exception when retrieving investment accounts using a relational database.
* 03/23/2019 Updated to the latest Hibernate dependency.
* 03/22/2019 Updated Russian translation. _[pchurzin]_
* 03/22/2019 Reporting would fail if Java encountered a font file it did not like.
* 03/21/2019 Fixed wrong currency symbol in Debit/Credit Columns if using a full format. (GitHub Issue #75)
* 03/19/2019 Do a better job of reporting bootloader network errors.
* 03/19/2019 Disabled Ctl-C shortcut for closing a file (Conflicts with a paste command).
* 03/18/2019 Prevent an exception from occurring if a default directory does not exist.
* 03/16/2019 Changed the download link in the Windows launcher to use a correct JDK.

== Release 3.0.0
* 03/14/2019 Updated to the latest H2 and Netty dependencies.
* 03/13/2019 Control of report resolution was added to the Balance Sheet and Net Worth reports.
* 03/12/2019 Corrected localization issues with the Default Currency and Locale selection dialogs.
* 03/12/2019 Updated to JavaFX 12 (Java 11 Compatible).
* 03/10/2019 Made the Options dialog accessible without a file loaded.
* 03/10/2019 Number formats can now be chosen using the Options dialog and are more consistent.  This allows full
             control of the display of register values and provides a work around for a known JDK 11 bug.
* 03/10/2019 Date format selection was moved to the Formats Tab in the Options dialog for UI consistency.
* 03/08/2019 Disabled generation of the faulty -fx.bat file in the distribution.
* 03/07/2019 Decimal fields now use an internal math interpreter instead of the Javascript interpreter.
* 03/05/2019 Updated to latest h2, Apache Poi, and sl4j dependencies.
* 03/05/2019 Minor internal changes to take advantage of Java 11 APIs.

== Release 3.0.0-b1
* 02/27/2019 jGnash is designed to operate with Java 11 and newer.
* 02/27/2019 Removed support for old Swing UI.
* 02/27/2019 Jasper is no longer used for report generation.  jGnash now uses it's own internal reporting API.

== Release 2.36.2
* 02/17/2019 Fixed an issue preventing the old Swing UI from running with Java 11 (Swing).
* 02/10/2019 Prevent an exception when importing odd OFX files using an XML declaration. (GitHub Issue #72)
* 02/10/2019 Update to the latest Hibernate, Netty, and HikariCP dependencies.  This improves compatibility with Java 9+.
* 01/14/2019 jGnash would not start on a early access version of Java 8 (Swing, Fx, GitHub Issue #71)
* 01/11/2019 Corrected an exception when the date picker was cleared and focus was lost (Fx, GitHub PR #70) _[pchurzin]_
* 12/24/2018 Updated Polish translation (Swing, Fx) _[Sławomir Szarkowicz]_
* 12/24/2018 Fixed several localization issues reported by Sławomir Szarkowicz.
* 12/24/2018 Corrected a Runtime exception when trying to create a new file for locales without a country specified (JavaFx, Bug #65) _[valnaumov]_

== Release 2.36.1
* 11/06/2018 Updated to the latest Commons CSV dependency.
* 11/05/2018 Potential fix for a ConcurrentModificationException when changing budget properties (Swing, Bug #64)
* 11/04/2018 Updated to the latest Hibernate, Netty, XStream, and JUnit dependencies.
* 11/01/2018 Adjust width of the date column to match entry format and font scale. (Fx, GitHub Issue #63)
* 10/07/2018 Improved handling of OFXv2 files with incorrectly escaped XML characters. (Swing, Fx, GitHub Issue #61)
* 10/01/2018 Currency exchange rate is working again.  Yahoo continues to lock down their API. (Swing, Fx) _[Pranay Kumar]_
* 10/01/2018 Updated German translation. (Swing, Fx) _[Alex Werz]_
* 09/30/2018 Fixed an NPE when an ISIN was not specified for a security. (Swing, Fx) _[Pranay Kumar]_
* 09/16/2018 The new file wizard would not behave correctly if the task list was used instead of stepping sequentially
             using the Next button. This also impacted the Import Wizard. (Fx)

== Release 2.36.0
* 09/13/2018 Enhanced the MT940 parser to allow for an optional currency designator in decimal values. (Swing, Fx) _[Alex Werz]_
* 09/13/2018 Reinstated check and correct for data files with multiple root accounts and config objects. (Swing, Fx)
* 09/13/2018 The Fx interface now uses picocli for command line processing. (Fx)
* 09/13/2018 The old Swing interface no longer supports command line processing. (Swing)
* 09/10/2018 Fixed a bug that was preventing initialization of a new user specified portable preference file. (Fx)
* 09/09/2018 Fixed a random stability issue with client / server operation discovered during unit testing. (Swing, Fx)
* 09/09/2018 Updated to the latest Apache POI dependency.
* 09/09/2018 Updated manual with proper use of escape characters on the command line for file names.
* 09/06/2018 Dropped use of log4j as it is no longer a needed dependency.

== Release 2.35.1
* 08/26/2018 Updated to the latest Netty dependency.
* 08/25/2018 Fixed a bug when loading files using a very old UUID format. (Swing, Fx)
* 08/24/2018 Fixed several large memory leaks in the jGnashFx user interface. (Fx)
* 08/18/2018 Tightened up API for adding and removing securities to accounts to prevent corruption.
* 08/17/2018 Updated to the latest Hibernate dependency.

== Release 2.35.0 __(File format change)__
=== Notes:
Relational databases will need to be saved to a .xml or .bxds file format in the prior release of jGnash.  They may
be saved back to a relational database format afterwards.

* 08/12/2018 Fixed a layout bug that was preventing the Investment Transaction dialog from showing the full form.  (Fx)
* 08/12/2018 Improved the layout behavior of the Transaction dialog.  (Fx)
* 08/12/2018 Fixed a bug that was causing decimal artifacts to occur in empty rows of the reminders table when using
             Java 10. (Fx)
* 08/12/2018 Prevent an "illegal reflective access operation" from occurring on Java 9 and newer.
* 08/10/2018 Reimplemented the detailed gains and loss control to support use in Java 10. (Fx)
* 07/29/2018 Changes were made to make migration to Java 10+ easier.
* 07/29/2018 Use Stax instead of kxml to make migration to Java 10+ easier.
* 07/28/2018 Migrated test system to JUnit 5.
* 07/28/2018 Updated to the latest Netty dependency.
* 07/06/2018 Reduced memory usage and improved performance for relational database users.
* 07/01/2018 Removed support for handling old XML file formats from 2017 and detection of 1.x files.
* 07/01/2018 Removed Dump Heap button from Console Dialog because API use is restricted in Java 9 and newer. (Swing)
* 06/24/2018 Replaced c3p0 with HikariCP for reduced application size and improved performance.
* 06/24/2018 Updated to the latest Hibernate dependency.  This breaks schema compatibility with older relational
             database files.
* 06/24/2018 Dropped support for the old jgnash Hibernate persistence unit / schema.

== Release 2.34.1
* 06/07/18 Updated Russian translation. (Swing, Fx) _[pchurzin]_
* 06/07/18 Updated to the latest Hibernate, Netty, Hsqldb, and DynamicJasper dependencies.
* 06/06/18 Remove stale relational database lock files if a crash had occurred.
* 03/28/18 Updated to the latest H2 dependency.
* 02/06/18 Improved snooze behavior for reminders. (Fx) _[leeboardtools]_
* 02/05/18 Corrected a race condition in the transaction register that would cause a rare sorting issue and IndexOutOfBoundsExceptions. (Fx)
* 02/03/18 Updated to the latest Netty dependency.
* 02/02/18 Corrected an IllegalStateException when manually reconciling transactions. (Fx)
* 01/12/18 Nested Investment accounts were summing with small fractional errors depending on Market price. (Swing, Fx)

== Release 2.34.0
* 01/06/18 Significant update to the Polish translation _[Sławomir Szarkowicz]_
* 01/06/18 Updated to latest Netty dependency.
* 12/10/17 Another significant update for the zh-ch locale translation. (Swing, Fx) _[kevinzhwl]_
* 12/02/17 The Portfolio report now calculates Internal Rate of Return. (Swing, Fx) _[t-pa]_
* 11/28/17 Improve MT940 import to handle Kontobezeichung (Swing, Fx) _[laeubi and sschuberth]_
* 11/22/17 Prevent a deadlock due to a poor or corrupt printer configuration at the OS level. (Swing, Fx)
* 11/22/17 Fixed a Platform thread exception on exit when the application was closed soon after closing a Reminder dialog. (Fx)
* 11/19/17 Expanded the import filter script interface to allow advanced manipulation of ImportTransactions. (Fx)
* 11/18/17 Switched from Opencsv to Apache Commons CSV for exports to reduce distribution size and dependencies. (Swing, Fx)

== Release 2.33.2
* 11/12/17 The opening Reconcile dialog now has a button to calculate ending balance based on the closing date. (Fx) _[Pranay Kumar]_
* 11/11/17 The Reminders dialog would not close properly if dismissed with a button. (Fx)
* 11/11/17 The Reminders dialog was not correctly restoring the last used snooze period. (Fx)
* 11/11/17 Corrected a Hibernate configure error for Account objects that may have been causing subtle bugs. (Swing, Fx)
* 11/08/17 New workaround for Yahoo discontinuing a portion of their Securites history API. (Swing, Fx)
* 11/06/17 Correct handling of special characters when importing OFX files. (Swing, Fx, GitHub Issue #35)
* 11/06/17 Ignore cash transfers for dividends in realized gains calculations. (Swing, Fx) _[t-pa]_
* 11/06/17 Significant update for the zh-ch locale translation. (Swing, Fx) _[kevinzhwl]_
* 10/22/17 Updated to latest Hibernate and Netty dependencies.
* 08/19/17 Switched from a MD5 to SHA-256 hash function for encrypted client / server operation. (Swing, Fx)
* 08/19/17 Protect against the import of an OFX file with malicious content. (Swing, Fx)

== Release 2.33.1
* 08/18/17 Corrected an issue with optimal Date storage in xml and bxds files caused by a regression introduced in 2.33.0
* 08/16/17 The OFX export will now generate required information for transfer between accounts. (Swing, Fx)
* 08/15/17 Simple use of portable preferences was failing with use of -p or --portable. (Swing, Fx)
* 08/15/17 Display a console message with the successful uninstallation of application preferences. (Swing, Fx)
* 08/15/17 The command line help system was not being displayed on the console correctly. (Swing, Fx)
* 08/14/17 OFX import now supports transfers between accounts. (Fx)
* 08/13/17 The open dialog was incorrectly allowing selection of a file when a remote connection was selected. (Fx)
* 08/13/17 Internal were changes made to allow operation with Java 9 with the addition of the command line option
           `--add-modules java.xml.bind`. (Swing, Fx)

== Release 2.33.0
* 08/11/17 Updated to the latest Netty dependency.
* 08/09/17 Implemented amortized payments for the Fx interface. (Fx)
* 07/31/17 Build system has been converted to Gradle.  Unix executable shell scripts are now provided.
* 07/31/17 Updated to the latest jopt-simple dependency.
* 07/09/17 Updated to the latest DynamicJasper and JasperReports dependencies.
* 07/09/17 Updated to the latest Apache POI dependency.
* 07/02/17 Further improvements to handling Yahoo Fiance API errors.
* 07/02/17 Potential fix for a Budget Exception occurring when OSX users are using a relational database.
* 06/19/17 Added a command button to execute a Reminder on demand. (Fx)
* 06/16/17 Updated to the latest Netty dependency.
* 06/16/17 Updated to the latest XStream dependency.
* 06/16/17 Updated to the latest H2 database dependency.

== Release 2.32.0
* 06/13/17 Updated to the new Yahoo Finance API for retrieving historical stock price information.
* 06/12/17 The security history chart would incorrectly show a prior chart if no data existed. (Fx)
* 06/11/17 Updated to the new Yahoo Finance API for retrieving dividend and stock split information.
* 06/03/17 Expanded the manual content for importing transactions.
* 06/03/17 Fixed a regression that was preventing the selection of the transaction's account when importing. (Fx)
* 05/30/17 Added the ability to pre-process imported transaction memos and payees using user supplied JavaScript. (Fx)
* 05/28/17 Minor improvements to the button behavior when editing the transaction number list. (Fx)
* 05/22/17 Updated to the latest Netty dependency.
* 05/14/17 Minor internal changes to remove the dependency on ControlsFX. (Fx)
* 05/14/17 The Enter button should be disabled if the form is not valid for investment transactions and split entries. (Fx)
* 05/13/17 Reworked exchange rate popup because display quality was inconsistent when first shown. (Fx)
* 05/11/17 Fixed missing icons for the currency exchange rate dialog. (Fx)

== Release 2.31.0
* 05/10/17 Added a General configuration option to allow full manual control of table column widths. (Fx)
* 05/10/17 The Options dialog now remembers the last tab that was used. (Fx)
* 05/08/17 Corrected handling of OFX files written with a windows-1252 character set. (Swing, Fx)
* 05/08/17 Prevent ghosting horizontal scrollbars when resizing the main window. (Fx)
* 05/07/17 Table Column sizes (register & reconcile) are now correctly remembered, restored, and scaled. (Fx)
* 05/06/17 Updated to the latest Netty dependency.
* 05/06/17 The reminder dialog now closes itself automatically if it was shown in the background while a file close was
           started concurrently. (Fx)
* 04/28/17 Dependency on FontAwesomeFx is no longer needed. (Fx)
* 04/24/17 Updated to the latest H2 database dependency.
* 04/17/17 Yahoo Security Download now requires use of HTTPS for downloads. (Swing, Fx)
* 04/17/17 Improved sizing of the open dialog for the Fx interface (Fx, GitHub Issue #25) _[Pranay Kumar]_
* 04/17/17 Cleaned up build system.  JGoodies dependencies now come from Maven Central
* 04/15/17 Updated to the latest Hibernate and HSQLDB dependencies.
* 04/10/17 Corrected an IndexOutOfBoundsException occurring during Transaction import (OFX, QIF) of a quantity not large
           enough to fill the table. (Fx)
* 04/09/17 Entry of date separators is now more flexible and allows use of ',' '.' '/' and '\' characters for all locales. (Fx)
* 04/09/17 Relaxed date entry requirements.  Single digit months may be now be typed in. (Swing, Fx)
* 04/09/17 The Account Register report was not reporting split entries correctly and consistent with the UI. (Fx)

== Release 2.30.0
* 04/09/17 Fixed a bug that was causing Buy and Sell transactions not using the cash balance of the investment account
           to generate an incorrect cash account amount. (Fx)
* 04/06/17 Fixed an issue with importing OFX 1.x files with ugly white space formatting. (Swing, Fx)
* 03/30/17 Added support for the H2 MVStore database file format.
* 03/30/17 Updated to the latest H2 database dependency
* 03/26/17 Updated to the latest Hibernate dependency.
* 03/25/17 The payee for Reinvested Dividends was not being generated correctly. (Swing, Fx)
* 03/24/17 OFX import of investment transactions is supported for Buys, Sells, Dividends, and Reinvested Dividends.
* 03/22/17 Corrected a random IllegalStateException occurring during transaction edits. (Fx)
* 03/11/17 Updated to the latest Netty dependency.

== Release 2.29.0
* 02/25/17 Improved UI performance when performing large batch updates of transactions. (Fx, GitHub Issue #23)
* 02/24/17 Updated to the latest Hibernate dependency.
* 02/22/17 Backup files were not being preserved correctly in some instances depending on the pattern of the file names
           in the same directory and if they contained a '-' character. (Swing, Fx)
* 02/13/17 jGnashFx Users are required to use Java 8 Update 71 or newer due to critical Java bugs. (Fx)
* 02/11/17 Clicking on an Income or Expense bar within the Income Expense Bar Chart will show the details for the
           period within a pie chart. (Fx) _[Pranay Kumar]_
* 02/07/17 Improved UI behavior when performing a large batch delete of transactions. (Fx)
* 02/06/17 An OFX import now prevents initial assignment to the wrong account type. (Fx)
* 02/03/17 Updated to the latest Netty and JOpt Simple dependencies.
* 02/01/17 Fixed a StringIndexOutOfBoundsException that was occurring when escaping out of a text field on MacOS. (Fx)
* 01/30/17 Fixed a NPE that was occurring when importing transactions. (Fx)
* 01/30/17 Corrected an OFX import regression that reduced effectiveness of detecting a duplicate import. (Swing, Fx)
* 01/29/17 Entity trash was being checked too frequently. (Swing, Fx, GitHub Issue #21)

== Release 2.28.4
* 01/26/17 Fixed an OFX import bug.  File header was in an unanticipated format that prevented correct identification.

== Release 2.28.3
* 01/23/17 Manual was expanded with specifics of transaction entry
* 01/20/17 Updated to the latest Hibernate and HSQLDB dependencies.
* 01/18/17 Corrected a performance regression loading and saving bxds and zip files introduced in 2.28.0.
* 01/17/17 Updates and  corrections to translations.  Parts of text for some languages were corrupt due to an editor bug.
* 01/15/17 More stability improvements when under heavy background loads and using a relational database.

== Release 2.28.2
* 01/14/17 Corrected a bug with file locking on Windows OS.
* 01/14/17 Added the Account and Amount columns to the Reminders table. (Fx)
* 01/14/17 Corrected errors with the Polish translation. (Sławomir Szarkowicz)
* 01/14/17 Fixed a regression that removed the Ticker/Investment column from the Investment account register. (Fx)

== Release 2.28.1
* 01/14/17 Corrected issues with inconsistent behavior of the reported memos of split transactions. (Swing, Fx)
* 01/14/17 Updated to the latest Netty dependency.
* 01/08/17 The Investment Register was not sizing the Quantity column correctly. (Fx)
* 01/08/17 Fixed an IllegalArgumentException that was occurring if the option "Next time jGnash starts" was used when
           dismissing the Reminders dialog. (Fx)
* 01/08/17 jGnash now uses a priority based model for the handling of internal tasks to prevent deadlocks from
           background operations.  This corrects some reported bugs with random freezing and hanging of the UI. (Swing, Fx)
* 01/07/17 Updated to the latest Hibernate dependency.
* 12/01/16 Corrected an NPE that was occurring during import of a OFX/QFX files. (Fx)
* 11/30/16 Improved the behavior of background removal of securities history.

== Release 2.28.0
* 11/27/16 Added the transaction timestamp to the CSV export. (Swing, Fx)
* 11/27/16 The xls and xlsx Account exports were broken by the addition of timestamps in Release 2.27.0. (Swing, Fx)
* 11/27/16 Updated to the latest Hibernate, DynamicJasper, JasperReports and OpenCSV dependencies.
* 11/26/16 The Account Register report was broken by the addition of timestamps in Release 2.27.0. (Fx)
* 11/26/16 An exception was occurring if Budgeting was being used and the window was too small to display data. (Fx)
* 11/26/16 Corrected sizing issues in the Budget interface if the screen was very wide and the budget was configured to
           use a small number of periods. (Fx)
* 11/26/16 Column widths are preserved so automatic column width resizing is less notable. (Fx)
* 11/26/16 Fixed a NPE triggered by a file load while a file is already being loaded. (Fx)
* 11/24/16 Columns were not resize correctly when adding or removing transactions. (Fx)
* 11/24/16 Delay the upgrade notification a bit more for a cleaner startup for some users. (Fx)
* 11/23/16 Added capability to cull down unneeded securities history as a background operation. This can reduce file
           size and improve overall performance. (Fx)
* 11/23/16 Improved performance when using a relational database and updating securities history. (Swing, Fx)
* 11/20/16 jGnash would stall and appear to be hung if a large group of transactions or security history was being
           removed when using a relational database. (Swing, Fx)
* 11/14/16 Corrected a rare ConcurrentModificationException on systems under heavy loads. (Swing, Fx)
* 11/08/16 Account ComboBox selection can be made using the first letter of the account. (Fx) _[Pranay Kumar]_
* 11/08/16 Up and Down arrows can be used for selection within the Transaction number box
* 11/05/16 Improved visual feedback for placeholder accounts and sums in the Budget interface. (Fx) (Feature Request 116)

== Release 2.27.0
* 11/05/16 Improved window positioning behavior on multi-monitor systems. (Fx)
* 11/05/16 The Budget Goals dialog had the wrong title and layout behavior was poor. (Fx)
* 11/03/16 Budgets results may now be display as running totals instead of per period values. (Fx)
* 10/26/16 Improved the density and layout stability of the budget view. (Fx)
* 10/24/16 Added selection buttons to the Reminders notification dialog to reduce required effort. (Fx)
* 10/24/16 The Periodic Account Balance chart was improved with more selectable periods and better button names. (Fx)
* 10/24/16 The Income and Expense bar chart was freezing due to an infinite loop. (Fx) _[Pranay Kumar]_
* 10/24/16 Improved stability of test and build for slow or virtualized systems.
* 10/23/16 The focus and accent colors for the Fx UI can now be changed. (Fx)
* 10/22/16 Corrected some font scaling issues within the UI. (Fx)
* 10/22/16 Improved column layout behavior when changing the default font scale. (Fx)
* 10/18/16 Transaction timestamps are now strictly controlled.  Alternation of a transaction including reconciliation
           will alter the timestamp.
* 10/18/16 A transaction entry timestamp column has been added to the register.  It is hidden by default. (Fx)
* 10/17/16 Prevent an IllegalArgumentException from occurring if a default or prior directory is missing when attempting
           to select a file. (Fx)
* 10/16/16 Added an option to control how Bayesian model matches transactions to accounts when importing. (Fx)
* 10/16/16 Make the last selected transaction account sticky for the OFX/QIF/MT940 Import wizard. (Fx)
* 10/14/16 The OFX/QIF/MT940 Import wizard was not displaying consistent precision for transaction amounts. (Fx)

== Release 2.26.1
* 10/13/16 Binary and XML files were not loading in the Fx interface. (Fx)

== Release 2.26.0 __(File format change)__
=== Notes:
H2 databases will be upgraded automatically.

HyperSql (*.script) databases will need to be saved to another file format in the prior release of jGnash.  They may
be saved back to a HyperSql database afterwards.

* 10/12/16 Added an option to invert the sign of Credit, Liability, Equity, and Income accounts for the Periodic
           Account Balance chart.
* 10/10/16 Fixed another transaction and security history concurrency bug for relational databases. (Swing, Fx)
* 10/09/16 The initial check for recurring transactions / reminders was taking too long. (Fx)
* 10/04/16 Add utility method to pack and upgrade older databases. (Fx)
* 09/07/16 Added work around for JavaFx bug JDK-8132897. Using a ComboBox was causing an application crash when running
           on the Windows platform. (Fx)
* 09/03/16 Improved predictability of the sort order of transactions with the same date without an assigned transaction
           number. (Swing, Fx)
* 08/29/16 Internal cleanup, removal of duplicated code.
* 08/28/16 The Open dialog was not behaving correctly if a remote connection was used for the prior session. (Fx)
* 08/21/16 Updated to the latest Hibernate dependency.  HyperSql (*.script) users will need to save to a different file
           format before updating to this release.  You may revert back to HyperSql after the upgrade.
* 08/21/16 Removed support for corrections to older file formats (Prior to release 2.22.0).  Existing files must have
           been loaded with jGnash release 2.22 - 2.25 prior to using with this release.

== Release 2.25.0
* 08/20/16 JavaFx interface is now considered stable for daily use.  Remove -ea suffix off executables. (Fx)
* 08/16/16 Fixed a rare transaction and security history concurrency bug for relational databases. (Swing, Fx)
* 08/11/16 Running totals for Spit transaction forms were not updating correctly. (Fx)
* 07/10/16 Command line options have changed, they now use '--' instead of '-'. See the manual for details. (Swing)
* 07/05/16 Integrated help has been removed from the Swing interface.  Help is provided with the supplied Manual.pdf.
         The old help system was limiting the type and quality of documentation that could be generated. (Swing)
* 07/05/16 The Check Designer Dialog button texts were not displayed correctly. (Swing)
* 07/04/16 The mt940 import now works with the Fx interface. (Fx)
* 07/04/16 Plugin API has been changed to allow a plugin to support the Swing and Fx interface. (Swing, Fx)
* 07/02/16 Plugin API implemented for the Fx interface. (Fx)
* 06/30/16 Plugins may now be placed in $HOME/.jgnash/plugins for *nix based OS's or
         C:\Users\user\AppData\Local\jgnash\plugins for Windows users. This makes upgrades easier for custom plugins.
* 06/26/16 Plugins were not being loaded from the correct location.  This prevented the mt940 plugin from loading. (Swing)
* 06/26/16 Added print capability and a status bar to the transaction attachment viewer. (Fx)

== Release 2.24.0
* 06/23/16 Improved performance for loading large files, working with large accounts and reports. (Swing, Fx)
* 06/22/16 Fixed some bugs related to editing of split transactions. (Fx)
* 06/22/16 Enable use of concatenated memos within the Swing interface. (Swing)
* 06/19/16 Improve handling of JDBC connection errors. (Swing, Fx)
* 06/19/16 The Fx UI would not completely shut down in some rare instances. (Fx)
* 06/18/16 Shutdown of server was not working correctly. (Fx)
* 06/17/16 Implemented use of command line options for the Fx interface.  (Fx)
* 06/09/16 Implemented the Payee Pie chart for the Fx interface.  (Fx)
* 06/02/16 The Income and Expense Pie chart now uses a DoughnutChart variation. (Fx)
* 05/27/16 Update to the latest Netty and include only the needed dependencies. (Swing, Fx)
* 05/26/16 Improved the name of the application in the OSX and Gnome global menu. (Fx)

== Release 2.23.0
* 05/14/16 Added the Periodic Account Balance report. (Fx)
* 05/04/16 Implemented the Reminders dialog for the FX interface. (Fx)
* 05/03/16 Implemented the "Shutdown Server" command for the FX interface. (Fx)
* 05/03/16 Added access to the Budget Manager from the Tools Menu. (Fx)
* 05/02/16 Implemented "File | Save As" capability for the FX interface. (Fx)
* 05/02/16 Implemented Password Change capability for relational databases. (Fx)
* 05/01/16 Modified transactions were not refreshing consistently in the register table. (Fx)
* 04/26/16 Fixed import of an account tree when using a relational database. (Swing, Fx)
* 04/25/16 Added Account structure import and export capability. (Fx)
* 04/24/16 Display a wait indicator when a generating a large report. (Fx)
* 04/24/16 Added the Account Register Report. (Fx)
* 04/24/16 Added a Memo specific column to the investment register table and separated the Investment column (Fx)
* 04/17/16 Added an option to the split entry dialog to automatically concatenate the memos of split transactions.
         This will reduce file size if used and reduces split transaction entry effort. (Fx)
* 04/15/16 Display a message at startup when a newer version is available for download. (Swing, Fx)
* 04/10/16 Language files now use UTF-8 file encoding. (Swing, Fx)

== Release 2.22.1
* 04/03/16 Fix for Fx UI font scaling issues for locales that use a comma for the decimal separator. (t-pa)
* 03/29/16 Preserve the tree structure in budget exports. (t-pa)
* 03/28/16 Fixed random deadlocks when loading budgets in the Swing interface. (t-pa)
* 03/28/16 Corrected budget calculations for mixed child account types. (t-pa)
* 03/28/16 Added Polish translation (Sławomir Szarkowicz)
* 03/22/16 Fixed broken OFX export.
* 03/09/16 Correct issues with table column widths sizing themselves incorrectly. (Fx)
* 03/07/16 Budgets were not calculating net period amounts correctly for income and expense accounts. (Bug #216) (Swing, Fx)
* 02/28/16 Enable automatic load of the last file for the Fx interface. (Fx)
* 02/28/16 Force the Fx interface on Windows to use 95% font scaling for work around potential Hi-DPI display bugs. (Fx)
* 02/28/16 NPE was occurring when editing transactions with an empty payee or memo's. (Fx)
* 02/28/16 OFX/QFX files with a capitalised file extension were not visible for import. (Fx)

== Release 2.22.0 __(File format change)__
* 02/20/16 Fixed behavior of manual date input.  It would sometimes reposition the caret and ignore input. (Fx)
* 02/18/16 Fixed a bug that was preventing removal of stale data from the relational database file formats.
* 02/14/16 Changed storage format for Budgets
* 02/09/16 Enable Menu mnemonics for platforms that support it (Fx, Windows).  Changed mnemonics design so it is easier
         for translation and works for both Swing and Fx interfaces.
* 02/08/16 Added the Net Worth Report. (Fx)
* 02/06/16 Added the Balance Sheet Report. (Fx)
* 02/05/16 Added the Profit Loss Report. (Fx)
* 01/29/16 Added the Portfolio Report. (Fx)
* 01/29/16 The running balance in the register was not updating correctly with transaction changes. (Fx)
* 01/25/16 The transaction number ComboBox would not always capture a manually entered value. (Fx)
* 01/18/16 Incorrect accounts were available for selection in the account ComboBox. (Fx)
* 01/10/16 Added the Monthly Account Balance CSV export report to the jGnashFx UI. (Fx)

== Release 2.21.0
* 01/09/16 Fixed a bug that was causing Investment Accounts to loose Securities resulting in exceptions.  It was triggered
         when a Security was added to more than one Investment Account and only users of a relational database would be
         impacted. Files will be repaired automatically (Swing, Fx)
* 01/06/16 Fixed a regression that was preventing creation of new Reminders. (Fx)
* 01/06/16 The Reminder table was not updating correctly after a new recurring event had occurred. (Fx)
* 01/04/16 The Account type was being corrupted for top level accounts when editing properties. (Fx)
* 01/04/16 The default account type was not the same as the parent when creating a new account. (Fx)
* 12/27/15 Set an explicit and stable sort order for budget account groups. (Swing, Fx)
* 12/14/15 Added an Income / Expense Bar Chart report to the jGnashFx UI. (Fx)
* 12/13/15 Month labels for tabular reports were off by one. (Swing)
* 12/13/15 Added the Profit and Loss text report to the jGnashFx UI. (Fx)
* 12/12/15 Added an Income / Expense Pie Chart report to the jGnashFx UI. (Fx)
* 12/12/15 The Profit and Loss text report was failing to execute. (Swing)
* 12/08/15 An option to remember the last used transaction tab has been added. (Fx)
* 12/07/15 An option to change button order has been added if you do not like the OS default. (Fx)
* 11/27/15 The budget view will automatically focus the current period when first displayed. (Fx)
* 11/27/15 Fixed an IndexOutOfBounds exception when reducing the displayed period count for a budget. (Fx)
* 11/27/15 Improved column sizing for the account summary table within the budget view. (Fx)
* 11/26/15 Improved general dialog sizing and positioning behavior. (Fx)
* 11/24/15 The transaction register may now be filtered/searched by date, reconciled state, memo, and payee. (Fx only)

== Release 2.20.0
* 11/22/15 Fixed several potential locale specific bugs.
* 11/17/15 Added a context menu to the account tree table. (Fx)
* 11/16/15 Right aligned decimal values in the account tree table. (Fx)
* 11/16/15 Fixed the account code editing behavior from within the account tree table. (Fx)
* 11/16/15 Completed implementation of Budgeting for the jGnashFx UI.
* 11/15/15 Reduced distribution size by excluding compile time dependencies.
* 11/11/15 Budgeting now uses the ISO 8601 standard for handling weekly periods for consistency. (Swing)
* 11/11/15 Fixed several budgeting bugs related to 53 week years. (Swing)
* 11/10/15 Fixed an error that would occur when creating a new file and the given filename extension did not match the selected file type. (Fx)
* 11/10/15 Duplicate tabs were being created and an exception thrown when creating a new file. (Fx)
* 11/05/15 Added the ability to change the default date format to something other than the locale default. (Swing, Fx)
* 10/31/15 Fixed a file version check bug that was causing asset and liability accounts to lose their budget visibility.
* 10/31/15 Internal test framework should not leave files lying around anymore.
* 10/28/15 Fixed a bug with account combos not retaining their initial value. (Fx)
* 10/27/15 Improved font appearance by forcing smoothing type to gray. (Fx)
* 10/25/15 The last used tab of the primary interface is now restored at startup. (Fx)
* 10/24/15 Windows were not saving their size and location because of a race condition. (Fx)
* 10/24/15 Transaction number combo box was not working correctly. (Java Bug JDK-8136838 Fx)
* 10/18/15 Improved the column packing speed of the transaction register. (Fx)
* 10/17/15 The base font size will need to be reset after some code cleanup. (Fx)
* 10/17/15 Avoid extraneous automatic securities price updates during the weekend if at least one has occurred.
* 10/14/15 Fixed a race condition in the account ComboBox resulting in NPE when creating a new account. (Bug #212) (Fx)
* 10/14/15 Increase the darkness of the alternating tabular data row color from 2% to 6%. (Fx)
* 10/11/15 Added keyboard accelerators. (Fx)

== Release 2.19.0
* 10/10/15 Cleaned up Transaction Import API.  External import plugins will need to be updated.
* 10/09/15 Updated to latest Netty release
* 10/08/15 Improved layout behavior for investment transaction forms. (Fx)
* 10/07/15 Fixed a transaction entry bug when selecting the next available check number. (Fx)
* 10/05/15 Improved register layout. (Fx)
* 10/05/15 The reconcile button in the accounts list was not working. (Fx)
* 10/04/15 Fixed an NPE that could occur when creating a new account. (Fx)
* 10/04/15 Icons behave better when the base color and font size is changed. (Fx)
* 10/04/15 Implemented QIF import for the jGnashFx UI.
* 09/25/15 The QIF import utility has been improved to make a better determination of the date format automatically.
* 09/25/15 Some QIF imports would fail because of a date parsing regression in 2.17.0.
* 09/20/15 Fixed an OFX and QIF bug that was preventing matches of previous and manually entered transactions. (Swing, Fx)
* 09/20/15 Fixed an exception if an attempt was made to import an OFX or QIF file with a previously imported transaction. (Swing, Fx)
* 09/20/15 Implemented OFX import for the jGnashFx UI.
* 09/15/15 Fixed an exception when opening the Transaction Number configuration Dialog (Fx)
* 09/15/15 Added XLS, and XLSX files to the existing export capability of the transaction register (Swing)
* 09/15/15 Added CSV, OFX, XLS, and XLSX file export capability to the transaction register (Fx)
* 09/14/15 Fixed ellipse mark that made it into the Open toolbar button (Swing)

== Release 2.18.0
* 09/13/15 jGnashFx Early Access is now included with the distribution.
* 09/08/15 The NetWorth and BalanceSheet reports were not including Simple Investment account types.
* 09/06/15 Fixed QIF date parsing import bug introduced by 2.17.0
* 09/01/15 (FX) DatePicker now increments and decrements with use of vertical and horizontal scroll input
* 08/29/15 Remove support for importing jGnash 1.x files

== Release 2.17.1
* 09/01/15 Fix for a one day shift when converting Dates to LocalDates for XML and BXDS file formats.

== Release 2.17.0 __(File format change)__
* 08/28/15 Automatic backup preferences are now stored within the data file.  This is better for users working off of
         portable storage and multiple computers.  You will need to update your preferences with this release.
* 08/24/15 Securities historical charts now factor in stock splits and reverse splits.
* 08/23/15 The JavaFx UI for Securities history allows manual edits of split and dividend history.
* 08/16/15 File formats have changed and will not be backwards compatible with prior releases.
* 08/16/15 Added framework for handling historical information for stock splits and dividends. (File format change)
* 08/15/15 Migrated to use of the new Java 8 LocalDate classes.  This improves the overall application performance. (File format change)
* 08/12/15 Added RTF, and DOCX export capability for tabular reports.
* 08/12/15 Updated to the latest DynamicJasper.
* 08/11/15 Removed unused dependencies from the distribution files and build system.
* 08/02/15 Dependencies updates.
* 08/02/15 Temporally disable SSL jdbc connections until some bugs are sorted out.
* 08/02/15 Encrypt client/server communications if a password is specified without requiring explicit enabling of encryption.
* 07/31/15 Fixed a bug that would cause transfers of attachments in client/server mode to fail under Windows OS
* 07/26/15 The exchange rate dialog was not showing the close button and the clear button was in the wrong location.
* 07/22/15 Fixed a rare concurrency issue when updating securities history
* 07/20/15 Fixed an issue with historical investment downloads timing out when using a relational database.
* 07/11/15 Fixed issues when exporting an account structure when using a relational database.
* 07/10/15 Removed the days past due field in recurring form.  It's not needed because we have a Due date column now.
* 07/09/15 Add Last Posted date and Due date columns to the reminder table for easy reference
* 07/09/15 Add new capability to create a new recurring transaction from an existing transaction (context menu in the register)

== Release 2.16.0 __(Java 8)__
* 07/03/15 Dependencies updates, fixes for some Hsqldb database issues and minor performance improvements.
* 06/26/15 General cleanup and internal changes to support the new FX user interface in development.
* 05/31/15 An exception would occur if a Security was removed immediately after it was created and loaded with history (Bug #208)
* 05/31/15 Changed the reconcile checkbox to support three states for not-reconciled, cleared, and reconciled.
* 05/25/15 Return of Capital transactions were not being shown in the register table correctly.
* 05/14/15 Autocomplete now makes better choices for debit and credit transactions.
* 03/14/15 Ensure directory has been created first before trying to write a file.
* 03/14/15 Historical import dialog for securities did not correctly preset the prior month as intended.
* 03/14/15 Java 8 is now required for 2.16.0 and newer


== Release 2.15.2
* 02/12/15 Add tooltip to the investment gains and fees details buttons
* 02/09/15 SecurityHistoryNodes are now immutable to prevent database corruption
* 02/08/15 Insure resource cleanup if an SQL error is thrown
* 01/31/15 Fix for potential resource leak when exporting budgets to a spreadsheet
* 01/24/15 Fix sorting issues with securities and currency history dialogs
* 01/23/15 Initial sort order for security history was incorrect for XML and BXDS file formats
* 01/22/15 Dependencies updates, fix for some H2 database and Hibernate warnings

== Release 2.15.1
* 12/24/14 Fixed import of an exported account tree
* 12/24/14 Fixed security price import from Yahoo UK

== Release 2.15.0 __(File format change)__
* 12/07/14 Display a warning dialog if loan amortization is not configured instead of logging to the status bar.
* 12/03/14 Correct database at load if a transaction was incorrectly marked as orphaned and removable.
* 11/26/14 The simple investment account type was moved to it's own group to improve program logic
* 11/23/14 Active Account Securities were not marked to prevent removal in the Account Properties dialog.
* 11/22/14 Updated Spanish translation (Marcelo Abeldaño)
* 11/21/14 Reminder transactions were being incorrectly identified as orphaned.
* 11/12/14 Improved sort capability.  Accounts are now sorted by an account code and then by name.
* 11/11/14 Added a Code property to Accounts. Codes can be change to suit users needs. (Changes file format)
* 11/09/14 Improved reconciliation behavior.  Reconcile Settings are remembered from prior sessions and are intelligently updated.
* 11/09/14 Add sorting capability to the reconcile dialog tables.
* 11/08/14 A dialog will now be displayed when the file has been automatically upgraded and a backup of the old version made.
* 11/08/14 Relational database files will be altered automatically to address Hibernate Bug #HHH_9389
* 11/06/14 Settings for background updates of exchange rates and securities were moved into the data file (Changes file format)
* 11/06/14 Reconcile settings were moved into the data file for consistent behavior when the file is shared on multiple
         systems (Changes file format)

== Release 2.14.1
* 10/31/14 Fixed a bug that was preventing Securities history from being deleted if added within the same jGnash session
         for relational databases.
* 10/31/14 Updated to latest Hibernate 4.3.7 release
* 10/28/14 Minor translation improvements
* 10/26/14 After exporting a budget to XLS, you can left align a numeric column to see indents.
* 10/26/14 Fixed a bug with an empty account being changed into a placeholder account and retaining invalid budget goal
         information.  Placeholder accounts should only roll-up child account goals.
* 10/26/14 Bug fix for placeholder accounts not recalculating balances correctly if their currency is changed.
* 10/24/14 Improve shutdown behavior when interrupting background updates.
* 10/22/14 Fixed another race condition that could freeze the UI at startup
* 10/21/14 Fix for incorrect totals for register reports with split details shown.  The sum of the split was being
         calculated twice.  Correct behavior is to not show the sum of the splits.
* 10/21/14 Updated to the latest dependencies for report generation and XLS file exports.

== Release 2.14.0
* 10/19/14 PDF version of the integrated help is now packaged with the zip distribution.
* 10/14/14 When using the reconcile Wizard, Finish Later will now mark the transaction as Cleared and not Reconciled.
* 10/12/14 Redesigned the reconcile behavior to use the statement end date. Public and internal API's have changed for
         reconciliation and may break plugins.
* 10/12/14 Committing reconcile changes can take a long time when working remotely or using a relational database.
         Improve the UI behavior by showing a wait message instead of freezing the display.
* 10/12/14 Changing the reconciled state of a transaction using the context menu was not following the rules of the
         selected register option.
* 10/05/14 Bug fix for potential return of an incorrect closest by date market price for a security
* 10/05/14 Bug fix for potential erroneous removal of the prior days security history during a market price update
* 10/04/14 Bug fix for difficult to trigger Concurrent Modification error when updating stock prices
* 09/26/14 Bug fix for false positives identifying duplicate transactions when importing QIF files.
* 09/25/14 Handle non-standard OFX files that use commas as a decimal separator for amounts

== Release 2.13.6
* 09/21/14 Updated to latest Insubstantial release.  This fixes the Substance look and feel compatibility with Java 8
* 09/20/14 Updated to the latest JGoodies dependencies.  This should improve font appearance on Windows systems in some instances
* 09/20/14 Fixed the build process for the mt940 plugin so it always stays current
* 09/07/14 Internal cleanup, improve relational database load behaviors
* 07/29/14 Fixed a race condition that would cause a random NPE when loading security histories from a relational database
* 04/28/14 Force eager load of budget goals to prevent a random NPE at file load when using a relational database
* 04/28/14 Updated to the latest Netty
* 04/17/14 Updated to latest H2 database release
* 04/17/14 Updated to latest Hibernate 4.2.x release

== Release 2.13.5
* 02/23/14 Fixed an NPE when cleaning out orphaned transactions from a prior jGnash bug
* 02/22/14 Update to the latest HSQLDB database release
* 02/22/14 Update to the latest H2 database release
* 02/22/14 Update to latest XStream, security vulnerability CVE-2013-7285, an arbitrary execution of commands when unmarshalling
* 02/09/14 Minor API changes to allow operation using Java 8
* 01/25/14 Fixed a rare ConcurrentModificationException that would occur when updating stock prices.
* 01/12/14 Fixed another race condition that could freeze the UI at startup if loading a very large file.
* 01/12/14 Any newly added or modified transactions will be highlighted in the register table for easy identification.
* 01/11/14 Fixed a race condition that was preventing newly duplicated transactions from gaining focus in the register.
* 01/11/14 When an account register was open in it's own window, window focus could be lost when deleting and duplicating
         transactions.

== Release 2.13.4
* 01/01/14 Accounts appearing in the budget model now respect the budget visibility of the ancestor accounts.
* 01/01/14 Fixed a bug with encrypted file attachment transfers
* 12/31/13 Fixed a race condition that could hang the UI at startup when loading a large file.
* 12/31/13 In some cases, a file would not reopen if a relational database was not closed cleanly.
* 12/27/13 Update to the latest XStream
* 12/26/13 Improve font appearance when running under KDE
* 12/21/13 Correct Budget UI exceptions that were occurring when performing SaveAs operations.
* 12/15/13 Show full currency formatting in the Budget display, otherwise, currency of the account is not obvious.
* 12/15/13 A Java bug was preventing new files from being created if a default currency was not determinable.
* 12/12/13 Changed the name of the Budget Column from "Change" to "Actual" to clarify intent.

== Release 2.13.3
* 12/05/13 Client/Server communications are now fully encrypted if enabled from command line for supported locales.
* 11/29/13 Allow loading of a file with duplicate Config objects.  The file will be corrected at load time.

== Release 2.13.2
* 11/17/13 A caching bug was causing the first transaction added to an account after restart of jGnash to show up twice.
         After restart the duplicate transaction would go away.

== Release 2.13.1
* 11/12/13 Update to latest Netty, H2, and Hibernate dependencies.  Users using H2 database may notice more consistent
         shutdown times.
* 10/29/13 Fix a race condition that was causing an ArrayIndexOutOfBoundsException in the GUI when
         adding a new transaction.

== Release 2.13.0
* 10/15/13 Correctly report and handle an attempt to open a wrong file type. (Bug #206)
* 10/15/13 Correctly report an attempt to open a directory instead of a file. (Bug #205)
* 10/02/13 Excess UI updates could occur when updating a budget goal and create performance issues.
* 10/02/13 Fixed an exception that would occur when filling in a bi-weekly budget.
* 08/13/13 Improved UI performance of the busy indicator on slower machines (Klemen Zagar)
* 08/11/13 When saving a compressed backup on exit, use the OS's temporary directory to play nice with cloud services (Patch #55, Klemen Zagar)
* 07/10/13 Update to the latest JFreeChart
* 06/29/13 Added a new feature; Transactions may now have image attachments.
* 06/20/13 New client server architecture based on Hibernate/JPA2 with H2 or HSQLDB SQL database.  db4o support
         has been purged from the code base.
* 06/10/13 Improve dialog positioning when using multiple monitors and when using fewer monitors than the last run.
* 04/23/13 Use Netty instead of Mina for performance and for improved protocol support
* 04/21/13 Added a Money Market account type.
* 04/20/13 New Engine and account api for setting and accessing custom text based account properties.
* 04/20/13 File schema changes to support external links to files and custom tags for transaction entries.
* 04/04/13 Discover and remove orphaned transactions left behind when Reminders were removed.
* 04/03/13 Improve the shutdown experience if a file is not open.
* 03/30/13 Added a new command line option to enable the xrender pipeline for X11 based systems.
* 03/28/13 Prevent background updates from running during a shutdown if performed right after startup.
* 03/25/13 Create a versioned backup of the old file automatically if the file format has been changed.
* 03/21/13 Changed binary and xml file structure for amortization objects.

== Release 2.12.0
* 03/03/13 When importing transactions, display a tooltip for payee and memo fields to make transaction determination easier. (Feature Request #107)
* 03/02/13 Automatically update the exchange rate tables when a multi-currency transaction is entered for a given date if one has not been set.
* 03/01/13 Updated to DynamicJasper 4.0.3.
* 02/24/13 Corrections made to the Portuguese translation. (Fernando Ribeiro da Silva)
* 02/14/13 Updated the jGoodies libraries.
* 02/12/13 Updated to XStream 1.4.4.
* 02/12/13 Updated to SwingX 1.6.5.
* 02/12/13 Updated to Apache POI 3.9.
* 02/10/13 Changed the exit process so that the final file write and closure is complete before the UI disappears instead of afterwards.
* 01/30/13 Improved the natural sort order of investment transaction for improved consistency (Date, Type, Memo, Security, Modification Date, Internal Id)
* 01/20/13 Fix for IllegalArgumentException caused by reordering table columns
* 12/09/12 Added register option to restore the last used transaction tab
* 12/09/12 When modifying an existing account, the current account currency would not be set in the dialog correctly.
* 12/02/12 Update to latest Substance L&F
* 11/25/12 Make confirmation on transaction deletion the default.
* 11/24/12 Added basic OFX export of accounts (Investment accounts are still a work in progress)
* 11/23/12 Warn if you are using a db4o (jdb) and recommend that you save as another format
* 11/10/12 Added CSV export direct from the transaction register.
* 11/10/12 Backup files were not being created in the same directory as the data file.
* 11/04/12 Update to Mina 2.0.7

== Release 2.11.0
* 10/24/12 Tabular style reports will start with a better default page size the first time the report is run.
* 10/23/12 Reminder dates were not correct if it was modified after being executed.
* 10/21/12 Display a message if an error occurs during a budget export (Read only file, etc)
* 10/20/12 Reworked the Balance Sheet report.  Results are displayed by period instead of a running balance and retained
         income / expense is calculated.         
* 10/14/12 Added a new Simple Investment account type.  This can be used for Annuities or Guaranteed Retirement accounts
         that you cannot actively manage. 
* 10/14/12 Added a utility script that can be run to remove weekend security history.
* 10/14/12 Update to the latest Insubstantial/Substance L&F release.
* 10/13/12 Improve security price import from Yahoo.  Dates returned from Yahoo are now used.  This prevents
         history entries on weekends and financial holidays.
* 10/13/12 Corrections to the reporting in the Income and Expense by Payee pie chart report as well as GUI
         behavior improvements.  It now has a chart for debit and credits. (Pranay Kumar)
* 10/13/12 Updated DynamicJasper to the latest release.
* 10/11/12 Updated XStream and Mina dependencies to the latest releases.
* 10/08/12 Add new controls to the historical security import dialog to make selection of securities faster and easier.
* 10/07/12 The Income and Expense pie chart now displays the default currency in addition to the account
         currency when multiple currencies are being used. (Pranay Kumar)  
* 10/06/12 Added an option for matching to the last similar entry when entering transactions. (Pranay Kumar)
* 10/03/12 Updated the Spanish Translation. (Marcelo Abeldaño)
* 09/03/12 A exception would occur when trying to generate a loan payment with a zero percent interest rate.

== Release 2.10.0
* 09/02/12 The Jump button would not work from a register in a separate window (Bug #3563951)
* 09/02/12 Do not preload report fonts to reduce startup time and reduce memory usage if reports are not being generated.
* 08/28/12 Changed busy indicator for significant memory usage reduction.
* 07/17/12 Fix for printing checks on Windows printers.
* 07/12/12 Dividends were not showing a correct value in the register total column (Bug #3526172)
* 07/12/12 Code migrated to fully utilize Java 7 try-with-resources.
* 07/07/12 Fixed a memory leak that was occurring when loading plugins
* 05/27/12 Added workarounds for JVM bugs when using Gnome 3 and Cinnamon. Mouse behavior was not correct when the jGnash
         window was maximized.
* 05/18/12 Imported transactions are automatically assigned an account using a Naive Bayes classifier.
* 05/17/12 Improved imported transaction match against manually entered transactions

== Release 2.9.0
* 05/03/12 Check for Java 7 or newer before executing
* 05/02/12 Added an alternating pattern fill option to the budget goal entry dialog
* 04/26/12 Strip extra white space when importing OFX files
* 04/24/12 Warn if an attempt is made to modify a transaction with a locked account
* 04/24/12 Correctly handle the modification of a transaction against a hidden account
* 04/24/12 Mark newly imported QIF transactions so they can be considered for account matching (no change to file format)
* 04/24/12 The account tree would not display correctly after a new file was created until open and closed.
* 04/24/12 Make the new binary format the default for new files.
* 04/23/12 A new file would not be created if the specified directory did not exist.  jGnash will now create the
         directory tree automatically.
* 04/09/12 Added new fast and compact binary file format
* 04/07/12 Added a Smart fill panel to the budget goal entry dialog for historical entry and fill all
* 03/18/12 Fixed the import of Citibank QFX and OFX credit card exports.
* 03/17/12 Modularized jGnash into several Maven modules and separated the UI code from the core engine code
* 03/17/12 jGnash was causing Java 7 JRE to seg-fault on close.

== Release 2.8.0
* 03/10/12 Help build system no longer requires OS level installed dependencies
* 03/05/12 Update to Insubstantial 7.1 and the latest JGoodies dependencies
* 03/05/12 Fixed an NPE that would randomly occur at startup
* 03/05/12 Corrected budget UI controls state when adding a budget for the first time and deleting the last budget
* 03/04/12 Mavenized the help build system
* 02/15/12 Printable reports can now be saved as xls files
* 02/15/12 Improved mt940 import (Patch #3487030, Arnout Engelen)
* 02/14/12 Fixed issue with large budget values being clipped in the budget UI
* 02/13/12 Working xls and xlsx export of budget results
* 02/12/12 Improve handling of multiple currencies in the budget UI

== Release 2.7.0
* 02/08/12 Added functionality to sort the Profit and Loss report by Account balance and percentiles (Patch #3154343, Klemen Zagar)
* 02/06/12 Removed duplicate code in budget results UI
* 02/05/12 Fixed formatting of the creation date on printed and pdf reports
* 02/05/12 Updated to latest DynamicJasper and associated dependencies
* 02/05/12 Reduced complexity of the budget results UI code and eliminated redundant listeners
* 02/04/12 Rewrote the budget results calculation code
* 02/02/12 Updated Dutch translation (Patch #3482860, hellemans)
* 02/01/12 Transactions may now be modified through arrow key selection inside the register (Patch #3481312, hellemans)
* 01/29/12 Reworked the summary information for the budget view including the addition of a row footer and options
         to display the summary information

== Release 2.6.2
* 01/21/12 Set the jGnash file filter as the default when choosing a file
* 01/21/12 Improve budget UI performance when transaction event and budget changes occur
* 01/19/12 Budget results would randomly show 0 if the CPU was heavily loaded
* 01/15/12 Fix generation of weekly and bi-weekly budget dates for non-US locales; Do not assume Sunday is
         the first day of the week.
* 01/11/12 Budget totals were calculated incorrectly after a budget's properties/period were modified

== Release 2.6.1
* 01/08/12 A default user and password is now set if not specified when using client / server functionality
* 01/08/12 Add a Yearly period option for Budgets
* 01/08/12 Add a command line option to help detect UI code that hangs the EDT
* 01/07/12 Corrected some UI update and threading and performance issues with the Budget interface
* 01/03/12 Reinvested dividends were not showing a correct value in the register total column (Bug #3467513)
* 01/02/12 Close any open windows first when closing a file
* 01/01/12 Switched build system over to Maven and Ant hybrid
* 12/28/11 Expand budgeting help for budget properties
* 12/28/11 Add functionality to control account types for a budget (income, expense, asset, liability)
* 12/28/11 Selected budget year was not be used when editing goals and switching between budgets
* 12/26/11 Update to the latest, JGoodies, XStream, Mina, JFreeChart external dependencies
* 12/25/11 Update to the latest args4j external dependencies

== Release 2.6.0
* 12/24/11 Add help content for the new budget feature
* 12/14/11 Additional fixes for hierarchical display of the budget
* 12/13/11 Improved performance when working files with large account structure and many transactions.
* 12/11/11 The Budget account structure was not consistently updating when accounts were added, remove, or changed.
* 12/04/11 The total remaining for budgets periods was not calculated correctly (Chris Bunney)
* 12/03/11 Add ability to break budgets and goals down to daily entry if desired
* 12/01/11 Improve editing and focus behavior when changing budget goals
* 12/01/11 Fix for NPE occurring with Metal look and feels
* 11/26/11 Minor internal cleanup
* 11/22/11 Use the meta key instead of the control key on OSX systems
* 11/20/11 Completed fully functional hierarchical display for budgets
* 11/12/11 Minor improvements for behavior and appearance when running on OSX
* 10/25/11 Sum of transactions shown in the tooltip was not correct if the register was sorted.
* 10/17/11 Investment transaction total values were not displayed correctly in the register Total column (Bug #3408123)
* 10/15/11 Yahoo UK historical download address changed (Bug #3423566)
* 10/15/11 Improved behavior of auto completion. Added an option to control the case sensitivity of the match. Don't replace
         the memo or amount and account selection if entered before the payee field is matched. (Bug #3407399, #3407400)
* 10/07/11 Balance reversal selection was not being restored correctly in the option dialog (Bug #3417960)
* 10/04/11 Fixed OpenJDK specific bugs
* 09/15/11 Second period of the displayed budget was missing
* 09/14/11 Fix bug with exceptions occurring in the budget interface when the account structure changed
* 09/07/11 Improved overall UI layout for the new budget interface
* 09/06/11 Internal code cleanup, PMD, etc.
* 09/05/11 Menu items for Substance look and feels were not being selected when active (Bug #3404037)
* 09/04/11 Fix for enabled symbol when a substance look and feel is used (Bug #3403710)
* 09/04/11 Improve the behavior of the help dialog (Feature Request #3174487)
* 09/04/11 Add a double click listener for modifying reminders (Feature Request #3403673)
* 09/04/11 Add a delete key listener for reminders (Feature Request #3403736)
* 09/03/11 Add Sparklines to the budget display
* 09/01/11 Update default Portuguese accounts (Pietro A R CERCHIARI)
* 08/29/11 Update Italian translation (Davide)
* 08/26/11 Added a property to accounts to exclude them from budgets
* 08/26/11 Added a field to the account properties dialog for a long hidden bank id property
* 08/17/11 Fix a bug with UI actions not working when running from a jar file
* 08/14/11 Add a summary footer to the budget view
* 08/07/11 Remove locale specific information from CurrencyNode.  db4o cannot persist Java 7 Locale correctly and
         the Locale specific information has not adding value.
* 08/05/11 Fix Comparator so it plays nice with Java 7 (Exception: Comparison method violates its general contract!)
* 08/03/11 Make the current period visible by default in the budget view
* 08/02/11 Do not show hidden or locked accounts in the budget view
* 08/02/11 Do not show hidden accounts in the account selection combo boxes (Feature Request #3384937)
* 08/02/11 Show a tooltip in the budget views account header with the full account path
* 07/31/11 Added function to create a new budget based on historical data.
* 07/21/11 Fundamentals of a budgeting system are working.
* 07/21/11 Fixed a bug with the mt940 import plugin that was causing an exception if a file was not open instead of
         disabling the plugin until a file is loaded.
* 07/14/11 Fix for OFX import when preceding spaces are in the transaction amount
* 06/19/11 Update to latest JGoodies libraries
* 02/16/11 Check for multiple root accounts and correct if needed at startup.
* 02/15/11 Fixed a bug where an account would show twice in reports in very rare circumstances.
* 02/13/11 Minor selection and expansion performance improvement for the account view.
* 01/22/11 Corrected layout issues in the investment transaction entry forms
* 01/18/11 Mnemonics for menu items were not being shown
* 01/16/11 Base API for Budgets added to the engine
* 01/16/11 Use Annotations to reduce amount of managed code for UI actions

== Release 2.5.1
* 01/02/11 Added new option to change the font size of the Nimbus Look and Feel
* 01/02/11 Reorganized the Options Dialog to reduce the required space for small displays
* 01/02/11 Added option to control network connection timeouts
* 12/31/10 Add new variation of the Monthly Account Balance report (Patch #3087286, Pranay Kumar)
* 12/31/10 Dumped the jGnash.app OSX launcher... sometimes it works, and sometimes it does not depending on the
         age of the system.  Will now leave it up to the end user to sort it out. (Bug #3148438, Peter B. West)
* 12/31/10 Improve behavior of split entry dialog (Bug #3132102, Chris B)
* 12/31/10 jGnash 1.x import fixes and performance improvements (Bug #3147017, Klemen Zagar)
* 12/30/10 Code cleanup efforts
* 12/30/10 Protect against a null locale when importing jGnash 1.x file (Bug #3147015, Klemen Zagar)
* 12/30/10 Protect against an invalid file entry (Bug #3147013, Klemen Zagar)
* 12/30/10 Protect against NPE (Bug #3147012, Klemen Zagar)
* 12/05/10 Improve the performance of the Accounts list for large account structures and play nice with db4o 7+
* 12/05/10 Ensure XML background write thread is complete before another write can occur or jGnash can close (Bug #3071371)
* 11/28/10 Don't freeze the UI when duplicating a transaction on slow systems.
* 11/28/10 Update to SwingX 1.6.2
* 11/16/10 Fix poor button layout for wizard dialogs
* 10/18/10 Fix handling of the exchange rates for the pie chart report (Patch #3089661)
* 10/17/10 Protect against incomplete XML file writes
* 09/26/10 Enable selection of an account in the accounts tree by pressing the first letter of the account name

== Release 2.5.0
* 09/19/10 Added additional integrated help content.
* 09/18/10 Improved error handling when the selected font size for a report is too large.
* 09/12/10 Added new options to reverse the display of account balances (Patch #2935203, Peter Vida)
* 09/12/10 When opening an income account, select the income tab by default (Feature Request #2889091)
* 09/08/10 Cleaned up a console warning when displaying reports.
* 09/06/10 Reinvested dividend transaction fees were not being handled correctly. (Bug #2924555)
* 09/02/10 The exchanged amount in a multi-currency transaction would not be correct if a change in
         field focus had not occurred (Bug #3045847)
* 09/01/10 A Stack overflow was occurring when adding a new loan payment (Bug #3053384)
* 09/01/10 Accounts were not always visible when choosing from a dialog
* 08/31/10 UI components would not display correctly on OSX after integration of the Substance Look and Feel
* 08/29/10 Mt940 import converted to a jGnash Plugin
* 08/29/10 Finalized new Plugin API
* 08/27/10 Pieces of the Portuguese translation were missing
* 08/21/10 Update to Substance 6.1
* 08/21/10 Reports would not show if a default font was not available (Bug #3050057)
* 08/11/10 The color for reconciled balance in the account list view was not always correct (Bug #3040309)

== Release 2.4.1
* 07/21/10 Added CTRL-F4 shortcut to close the active register window (Feature Request #2889093)
* 07/21/10 Added an option to disable the Substance Look and Feel animations
* 07/21/10 The report print button would not work when using the Substance Look and Feel
* 07/21/10 Updated to the latest DynamicJasper and JasperReports

== Release 2.4.0
* 07/18/10 Add functionality to adjust the global font size when using the Substance look and feel
* 07/18/10 Add Startup option to control automatic load of the last open file (Feature Request #2933793)
* 07/18/10 Improve duplicate transaction functionality (Feature Request #1683578)
* 07/15/10 Fix for a random NPE occurring at startup (Bug #3020688)
* 07/12/10 Update to SwingX 1.6.1
* 07/12/10 Reworked the validation framework to use JXLayer
* 07/11/10 Integrate JXLayer into the UI to improve effects and behavior
* 07/09/10 A Portfolio report column name was not being displayed correctly
* 07/07/10 The expansion state of the account list view is now restored on start
* 07/02/10 Reimplement the account list view so the appearance is correct for certain look and feels
* 06/27/10 Add Substance Look and Feel to the main distribution

== Release 2.3.5
* 05/20/10 Removed percent gains and unrealized gains from portfolio report because they cannot
         be accurately calculated
* 05/08/10 Added Czech localization (Patch #2981896 & 2991446, Luboš Hilgert)
* 05/08/10 Update Portuguese localization (Patch #2996097, Marco A L Barbosa)
* 04/04/10 Do not allow the portfolio report to run if there are not any investment accounts present.
* 04/03/10 Fix typos (Patch #2981190, Nathan McCrina)
* 03/27/10 Prevent duplicate transaction dialog from resizing too small
* 03/17/10 Fix typos (Patch #2971980, Adrian A)
* 03/14/10 Portfolio cost basis was not being calculated correctly
* 03/14/10 The market value of investment accounts was not reported consistently (Bug #2822512)
* 03/13/10 Add a simple chart to the Security History dialog
* 03/10/10 Security price Table was sorting alphabetically instead of numerically (Bug #2940278)
* 03/09/10 Report unrealized gains correctly in the portfolio report.
* 03/06/10 Cleaned up internal exchange rate API.
* 02/24/10 Add context sensitive help capability.
* 02/24/10 Income tab names were reversed when using accounting terms.

== Release 2.3.4
* 02/21/10 Expanded help content
* 02/03/10 Add Ukrainian translation (Vitaliy Aksyonov)
* 01/20/10 Update to latest JGoodies Forms and Looks to improve layout on OSX and L&F issues on Windows 7
* 01/19/10 Improve report name consistency for Report/Exports (Patch #2935268, Peter Vida)
* 01/19/10 Reorganize the Profit Loss Text report into the Report/Exports menu (Patch #2935208, Peter Vida)
* 01/19/10 Use the scale value specified for Securities in the transaction register table (Peter Vida)
* 01/18/10 Add cost basis columns to the portfolio report
* 01/18/10 Add options to the Running and End-of-Month account chart reports to filter placeholder
         and locked accounts (Patch #2931574, Peter Vida)
* 01/17/10 XML file corruption could occur for fast parallel jGnash starts (Bug #2929425)
* 01/17/10 Improved detection of correct OFX encoding when importing (Bug #2929581)
* 01/16/10 Date selection field was no always displayed correctly (Bug #2931561, Peter Vida)
* 01/15/10 Fix distribution build so it works on all platforms (Bug #2929859)
* 01/10/10 Add filtering capability to the account register report (Pranay Kumar)
* 01/10/10 Allow double clicking a date in the dialog to automatically select and close (Patch #2929289, Peter Vida)
* 01/10/10 Exchange rates not saved to XML files. (Bug# 2928985, Peter Vida)
* 01/01/10 Improper amount of cash is transferred from e.g. a bank account to an investment
		 account when more than one fee is assigned to the sell share transaction. (Bug #2924554, Peter Vida)
* 12/26/09 Fixed a formatting problem affecting the Portfolio Report
* 12/26/09 Style the report footer text
* 12/26/09 Update to DynamicJasper 3.0.14

== Release 2.3.3
* 12/25/09 Reconcile columns were not labeled correctly in the dialog (Bug #2902064)
* 12/24/09 The latest memorized transaction would not always be recalled
* 12/17/09 The remote sever now performs periodic XML backups for long running periods if changes have been made
* 12/09/09 The Profit and Loss Text report was not including the start date as part of the reported balance (Bug #2909000)
* 12/07/09 Changes made to support operation as a webstart application (Patch #2908944)
* 11/09/09 Improve formatting of Quantities in the portfolio report (Bug #2892985)
* 11/08/09 Disable multiple selection of Reminders (Bug #2894147)
* 11/07/09 Exchange rate of modified transactions was being set to the current rate instead of the prior rate (Pranay Kumar)
* 11/06/09 Improve UI layout for small screens (netbooks)
* 11/03/09 Correctly show modifications to currencies without a restart
* 11/03/09 File import actions should be enabled only if a file is open (Bugs #2890420, #2890422, #2890426)
* 11/03/09 Update to SwingX 1.6

== Release 2.3.2
11/02/09 Reports with totals were broken in the 2.3.1 release (Bug #2890310)

== Release 2.3.1
* 10/30/09 Reports would hang if certain characters were in currency prefix or suffixes (Bug #2884085)
* 10/23/09 Transaction tab names were reversed when using accounting terms for credit and liability accounts (Bug #2770638)
* 10/19/09 Reminders with no last date would default to current date when using the XML file format (Bug #2860259)
* 10/18/09 Update to latest JGoodies look and feel
* 10/18/09 Use a temporary swap file when generating large reports
* 10/18/09 Add a group label to the reports to help improve readability
* 10/15/09 Update to latest DynamicJasper and JasperReports dependencies
* 10/15/09 Updated German translation (Adrian Gygax)
* 09/23/09 Fix for Bug #2863303, Improve UI behavior for duplicate transaction behavior (L2K)
* 07/31/09 Add Yahoo Australia as Quote Source (Rob Hills)
* 07/09/09 Lazily create the help broker and fail gracefully if an exception occurs instead of
         preventing the application from starting.
* 07/07/09 Show the sum of the selected transactions in the register using a tooltip
* 07/07/09 Liability register was missing the Jump button

== Release 2.3.0
* 06/26/09 Detect and correct accounts with self parenting
* 06/20/09 Prevent a user from assigning an account's parent as itself.
* 06/18/09 Begin migration to MigLayout to replace Forms Layout
* 06/07/09 Use JXColorSelectionButton to select register colors.
* 06/05/09 Add network activity indicator when updating security prices and exchange rates in the background.
* 06/04/09 Update to JasperReports 3.1.4
* 06/04/09 Add ellipsis symbol to truncated text in reports
* 06/04/09 Update to DynamicJasper 3.0.6
* 06/03/09 Correctly handle file encoding of OFX V1 files.
* 06/01/09 Add a new option to automatically select text when a field receives focus
* 05/31/09 New report to show income and expense by payee (Pranay Kumar)
* 05/29/09 Updated Portuguese translation (Pietro Augusto)
* 05/25/09 Improved handling of validation errors
* 05/04/09 Integrate the SwingX libraries for improved usability
* 04/22/09 Fix for Bug #2500229, Display a warning if a Security is not selected when creating an
         investment transaction.
* 04/22/09 Correctly handle an attempt to open a zero length file.
* 04/20/09 Fix for Bug #2734778, Default currency was not accessible immediately after creating a new XML file.
* 04/10/09 Add an escape key listener to most all dialogs and add additional bounds listening to dialogs that
         did not already have it.

== Release 2.2.0
* 03/31/09 Correct identification of OFX 2.0 files that are now starting to show up in the wild.
* 03/26/09 Fixed report of multiple currencies for the Monthly and End-of-Month account balance charts.
* 03/26/09 Switched to DocBook for creating content for the JavaHelp system.
* 03/26/09 Add menu commands to perform background updates on security prices and exchange rates.
* 03/25/09 Fix for bug #2690988, poor form layout behavior for recurring entry creation in OSX.
* 03/25/09 Various updates to the Spanish translation (Marcelo Abeldaño).
* 03/25/09 Transaction reconcile was not occurring per the selected options.
* 03/25/09 Reconciled state of the opposite side of a transaction was not preserved when modifying.
* 03/24/09 Fix for bug #2691568 (Andrey Bondarenko).
* 03/07/09 Much improved account tree UI behavior when security prices change.
* 03/05/09 Remove unused fields from the Create/Modify Security Dialog.
* 03/05/09 Improve amortization UI behavior.
* 03/04/09 Reporting has been reworked.  Report preferences are persistent; Font size is configurable;
         CSV export has been improved; Consistent appearance for all reports; Now uses Jasper and
         DynamicJasper report APIs.
* 02/15/09 Render investment quantities with a fixed decimal to improve appearance.

== Release 2.1.0
* 02/01/09 Fixed issues with multiple network clients not communicating with each other.
* 01/14/09 Fixed a problem with duplicate default currencies when creating a new default account set.
* 01/12/09 Investment account balance was not calculated correctly if the last transaction was a dividend
         and a security price for same date or after was not established.
* 01/04/09 Added an integrated help system.
* 12/30/08 Added -portable command line options to save jGnash preferences to an external location for
         users who want to run jGnash from a USB drive.

== Release 2.0.3
* 12/30/08 Checks would print with test border.
* 12/30/08 Feature Request #2474667, If an invalid file extension is provided during File |  Save As,
         default to the db4o file type and extension.
* 12/30/08 Fix for Bug #2474820, Performing File | Save As over the current file would result in an
         empty file and loss of data.
* 12/30/08 Update to XStream 1.3.1.  Update should improve XML performance.
* 12/30/08 Fix new file account structure and import regression.
* 12/30/08 Patch #2477090, MT940 import fix from Miroslav Holubec.
* 12/14/08 Add a shutdown option to automatically control the number of backup files.
* 12/05/08 The automatic Security price download would not work correctly if more than two Securities were configured
         with no download source.
* 12/04/08 jGnash can now import Ofx version 1 and 2 credit card account files.
* 12/03/08 jGnash can now import Ofx version 1 and 2 bank account files.
* 12/03/08 Fix problem with null account numbers

== Release 2.0.2
* 11/28/08 Set the default selected account for buy and sell transactions to the base investment account.
* 11/28/08 Fixed an incorrect warning to the console when modifying and reinvested dividend transaction.
* 11/28/08 Improved the appearance of the investment transaction entry panels when using the Nimbus look and feel.
* 11/26/08 Investment account balances were not always reflecting the latest security price.
* 11/23/08 Disable db4o defragment.  The defragment function is not stable and could cause corruption.
* 11/23/08 Fix for Bug #2334048, Available Securities dialog was pushing the parent frame to the back.
* 11/23/08 Fix for Bug #2332586, Modifying an investment transaction from a bank account register was not working.
* 11/23/08 Fix for Bug #2332540, Loss of focus on an empty numeric field in OSX was throwing an exception. (Fix from Petey)
* 11/23/08 Internal code cleanup
* 11/18/08 Dropped Beanshell support because it is no longer supported and does not work well with OSX
* 11/17/08 Converted the MonthBalanceCSV text report from a Beanshell script to a compiled report.
* 11/16/08 Converted the ProfitLoss text report from a Beanshell script to a compiled report.

== Release 2.0.1
* 11/16/08 Update to the latest Pentaho reporting jars.
* 11/15/08 Prevent the removal of a currency assigned to a security node.
* 11/10/08 Currency exchange rate was not factored in for investment transaction reconciliation.
* 11/10/08 Extend default security / exchange download to 30 seconds.  It was 10 seconds.
* 11/09/08 Fix for Bug #2246569, Date dialog was pushing the parent dialog to the back
* 11/09/08 Fix for Bug #2222143, Multiple RootAccounts were being created and making import
         look like it failed.

== Release 2.0.0
* 11/02/08 The reconciled market balance was not factoring in the exchange rate of currencies
* 11/02/08 Update to latest JGoodies Looks
* 10/29/08 Improve appearance of the date selector for modern look and feels (Nimbus and JGoodies)
* 10/27/08 Fix problem with Reminder modification resulting in a duplicate when
         using the XML file format
* 10/17/08 Reconciliation from transaction forms was not working correctly
* 10/17/08 Automatic reconciliation of income and expense accounts was not working correctly.
* 10/17/08 Transfer panel was missing the reconcile button
* 10/16/08 Recurring transaction reminders were not working unless a file was reloaded
         without UI restart
* 10/12/08 Fix Portfolio report summary row value
* 10/10/08 Updated Spanish translation (Marcelo Abeldaño)

== Release 2.0.0-RC4
* 10/05/08 Typing a 'T' or 't' inside a date field changes it to the current date.
* 10/05/08 Prevent an exception from occurring if the overall length of a date field is
         shortened when a shortcut key is used.
* 10/05/08 Update to the latest JGoodies Forms and Looks jars.
* 10/05/08 Fix problem with lost views when UI is restarted because of look and feel update
* 10/04/08 The enabled state of the recurring transaction panel was not correct
* 10/04/08 Fix the UI layout for the Account Register and Portfolio Reports
* 10/04/08 Remove unused jar dependency

== Release 2.0.0-RC3
* 10/01/08 Yahoo UK has reverted to the security symbol instead of the ISIN number for
         downloading data
* 10/01/08 Fix for Bug #1991337.  The portfolio report should use the account currency
         instead of the default currency, and it was not factoring in the exchange rate
         for securities with different reported currencies.
* 10/01/08 Change how UI elements are handled when a file is loaded and unload.  This
         circumvents Java Bug #6472844 which was causing a memory leak.
* 09/25/08 Yahoo security download info occasionally contains extra white space.  Protect
         against a NumberFormatException when parsing
* 09/23/08 Prevent incorrect moving of an account
* 09/23/08 Update to latest JFreeChart jar
* 09/23/08 Update to latest db40 6.4 jar
* 09/22/08 Fix for Bug #2080742.  The direction of the currency conversion was not correct
* 09/21/08 Correctly set the enabled state of the Reports menu when a file is not loaded
* 09/20/08 Prevent the import of a MT940 file if a jGnash file is not loaded
* 09/20/08 Fix for Bug #2098347.  Prevent the import of an OFX file if a jGnash file is not loaded
* 09/19/08 Fix the enabled state of the reminder panel buttons and prevent an NPE if
         a file is not loaded.
* 09/17/08 Fix the investment account reconciliation process
* 09/09/08 Fix the reported reconciled amount for investment accounts
* 08/27/08 Fix for Bug #2068074. Reminder modifications were not handled correctly
* 08/20/08 Localization fixes
* 08/18/08 Update to latest Pentaho reporting jar

== Release 2.0.0-RC2
* 08/18/08 Add sort capability to currency exchange table
* 08/17/08 Add Copy to Clipboard button to Console and Exception dialogs
* 08/17/08 HTTP connections were left open when downloading security history
* 08/17/08 Change sort order of the accounts for reports
* 08/17/08 Restart the UI when the L&F is changed to prevent Exceptions
* 08/15/08 Spanish translation fixes (Marcelo Abeldaño)
* 08/14/08 Correctly handle a filename passed by Windows if associated with jGnash
* 08/14/08 Fix NPE in recurring transactions
* 08/13/08 Fixed 1.x import and behavior of BuyX and SellX transactions
* 07/31/08 Change EDT check to used a command line option
* 07/30/08 The reconciled balance was not always rendered in the correct color
* 07/29/08 Use the default sort icons for the table header in the transaction register
* 07/28/08 Fix the appearance of the table header in the transaction register for newer
         look and feels
* 07/28/08 The duplicate function for transactions was not working for split transactions
* 07/27/08 Allow sorting of the security history table
* 07/27/08 Yahoo UK parser was not using the ISIN number
* 07/27/08 Fix more EDT issues

== Release 2.0.0-RC1
* 07/27/08 The lookup mechanism for default account sets when creating a new file did not work
         when jGnash was run from a jar or exe.
* 07/26/08 Currency Exchange history dialog was not always showing the correct conversion direction
* 07/23/08 Fix some initial display issues with SecurityHighLowChart
* 07/22/08 The XML storage container would not remove objects as expected
* 07/22/08 Add UI option to export timestamped and compressed file on exit
* 07/21/08 Update to JFreeChart 1.0.10.  Fixes some quirks with the income/expense pie chart
* 07/21/08 Create all UI elements on the EDT
* 07/19/08 Fix a NPE if the RootAccount AccountGroup is requested
* 07/19/08 Fix a potential problem with stray account properties being left in the object database
         upon account removal
* 07/18/08 Fix Profit and Loss text report and Monthly Balance export scripts
* 07/16/08 Save a time-stamped and compressed file on exit if enabled
* 07/14/08 Implement full Save As functionality.  It is now possible to switch between file formats.

== Release 2.0.0 - Beta 3
* 07/12/08 Lock XML file at OS level to prevent overwrite from multiple instances of jGnash
* 07/07/08 New icons to update UI appearance
* 07/06/08 Add a reconciled balance column to the accounts overview
* 07/06/08 XML Datastore is now working
* 06/30/08 Reinstate the 1.x status bar
* 06/29/08 Fixed a validation problem that prevented 0 scale currencies from being added to the database
* 06/28/08 Enable full support of client / server connection from the command line
* 06/21/08 AmortizeObject does not have to extend StoredObject
* 06/21/08 Enable option to load a file from the command line
* 06/20/08 TransactionEntry does not have to extend StoredObject
* 06/18/08 Balance Sheet report was not pulling all account types correctly
* 06/17/08 Fix bad validation code for jGnash 1.x import.  Depends on update release of Java 6.

== Release 2.0.0 - Beta 2
* 06/16/08 Preselect default transaction form tab based on account type
* 06/15/08 Dump GnuCash import support
* 06/15/08 SecurityNode and TransactionEntry db schema change.  db4o does not handle changes to enums well
* 06/14/08 Add "Checking" account type
* 06/14/08 Account db schema change.  db4o does not handle changes to enums well
* 06/13/08 If a transaction is dated for the future, italicize the font in the register table
* 06/13/08 Soft null check Workaround for a weird JVM bug for null assert checks on non-null Strings with international characters.
* 06/12/08 Autocomplete was occurring when text was being set vs typed causing mysterious changes to fields.
* 06/11/08 Add missing top level memo for transactions
* 06/11/08 Fix enabled state of the account combo for split transaction entry
* 06/09/08 Fix the display of split details for the account register report

== Release 2.0.0 - Beta 1
* 06/08/08 Reduce XML export file size by 45%
* 06/06/08 Dumped some unused legacy methods from TransactionEntry and subclasses
* 06/05/08 Fix transaction generation for basic double entry panel
* 06/05/08 Do not allow the currency of an account to be changed to it already contains transactions.
* 06/04/08 Overhauled the register tree panel code to fix column resize behavior and fix some bugs
* 06/03/08 Fix last known data corruption bug (Was not cloning TransactionEntries in the FeesPanel)
* 05/31/08 Reworked UI and API for reinvested transactions
* 05/26/08 Use new exchange rate UI for bank and transfer transactions
* 05/23/08 Remove duplicate code in TransactionDAO
* 05/22/08 New API and UI for handling capital gains and loss
* 05/22/08 Use java collections for storage instead of manually controlled arrays
* 05/08/08 Disable web update in Security History Dialog if a download source has not been selected for the security
* 04/12/08 Save and restore the last active view
* 04/06/08 Open streams were not being closed
* 04/06/08 Fixed formatting error in balance sheet and networth reports
* 03/25/08 Fixed import of jGnash 1.x Dividend transactions
* 03/20/08 Begin separation of BuyX and SellX transaction forms
* 03/10/08 Improve fees handling for BuyX transactions
* 03/05/08 Applied patch #1907963 for improved OFX parsing (Nicolas Bouillon)
* 03/03/08 Improved TransactionDialog
* 03/03/08 Fix divide by zero bug #1906150
* 03/01/08 Fix localization bug #1903842
* 02/29/08 Place nice with upcoming Nimbus look and feel
* 02/29/08 Update to jGoodies 1.2.0
* 02/27/08 Improve Next # action for transaction numbers Bug #1902455
* 02/21/08 Support for multiple security quote sources (Yahoo! and Yahoo! UK)
* 02/21/08 Improved OFX header parsing
* 01/31/08 Merge mt940 import support
* 01/30/08 Use of accounting terms were not correct in all cases.
* 01/22/08 Fixed handling for split and merge transactions in the portfolio report.
* 01/01/08 Reworked Dividend transactions and UI to support true double entry.
* 01/01/08 Use TimingFramework instead of jGoodies animations.
* 12/27/07 A button was added to the investment register to allow selection of available securities.
* 12/26/07 Improve generated payee of investment transactions.

== Release 2.0.0 - Alpha 3
* 12/26/07 Added Working OFX import for savings and checking accounts.
* 12/17/07 Improved new account wizard so user can add default account structures
* 12/10/07 Added import and export of the account tree
